#include <Bounce2.h>  // Bibliothek für entprellte Tasterabfrage einbinden

#define tasterStartStopp 5           // Pin 5 ist mit dem Taster verbunden
Bounce bceTasterStartStopp = Bounce(); // Erzeuge ein Bounce-Objekt für den Taster

#define statusLed 9                  // Pin 9 ist mit der Status-LED verbunden

bool ledStatus = false;             // Merker für den aktuellen LED-Zustand

void setup() {
  Serial.begin(9600);               // Serielle Kommunikation starten (9600 Baud)
  pinMode(statusLed, OUTPUT);       // Pin für die LED als Ausgang festlegen

  // Taster mit internem Pullup-Widerstand konfigurieren und dem Bounce-Objekt zuweisen
  bceTasterStartStopp.attach(tasterStartStopp, INPUT_PULLUP);
  bceTasterStartStopp.interval(5);  // Entprellzeit: 5 Millisekunden
}

void loop() {
  bceTasterStartStopp.update();     // Aktuellen Tasterstatus prüfen und entprellen

  // Prüfen, ob der Taster gerade gedrückt wurde (flanke von HIGH auf LOW)
  if (bceTasterStartStopp.fell()) {
    Serial.println("Taster gedrückt!");  // Ausgabe zur Kontrolle im seriellen Monitor
    ledStatus = !ledStatus;              // LED-Zustand umkehren (an/aus wechseln)
    digitalWrite(statusLed, ledStatus);  // LED entsprechend dem neuen Zustand setzen
  }
}
