#include <Bounce2.h>  // Bibliothek zur Tasterentprellung einbinden

#define buzzerLeft 10  // Pin 10 ist mit dem Buzzer verbunden

// Taster-Pin-Definitionen
#define tasterStartStopp 5
#define tasterPlus 8
#define tasterMinus 6
#define tasterSelect 7

// Erzeuge Bounce-Objekte für jeden Taster
Bounce bceTasterStartStopp = Bounce();
Bounce bceTasterPlus = Bounce();
Bounce bceTasterMinus = Bounce();
Bounce bceTasterSelect = Bounce();

const int DAUER = 125;  // Dauer des Tons in Millisekunden

void setup() {
  pinMode(buzzerLeft, OUTPUT);  // Buzzer-Pin als Ausgang setzen

  // Taster konfigurieren und entprellen
  bceTasterStartStopp.attach(tasterStartStopp, INPUT_PULLUP);
  bceTasterStartStopp.interval(5);  // 5 ms Entprellzeit

  bceTasterPlus.attach(tasterPlus, INPUT_PULLUP);
  bceTasterPlus.interval(5);

  bceTasterMinus.attach(tasterMinus, INPUT_PULLUP);
  bceTasterMinus.interval(5);

  bceTasterSelect.attach(tasterSelect, INPUT_PULLUP);
  bceTasterSelect.interval(5);
}

void loop() {
  // Alle Taster aktualisieren (entprellter Status)
  bceTasterStartStopp.update();
  bceTasterPlus.update();
  bceTasterMinus.update();
  bceTasterSelect.update();

  // Prüfe, welcher Taster gerade gedrückt wurde, und spiele einen Ton mit unterschiedlicher Frequenz
  if (bceTasterStartStopp.fell()) {
    tone(buzzerLeft, 600, DAUER);    // Ton mit 600 Hz bei Start/Stopp-Taster
  } else if (bceTasterPlus.fell()) {
    tone(buzzerLeft, 800, DAUER);    // Ton mit 800 Hz bei Plus-Taster
  } else if (bceTasterMinus.fell()) {
    tone(buzzerLeft, 1000, DAUER);   // Ton mit 1000 Hz bei Minus-Taster
  } else if (bceTasterSelect.fell()) {
    tone(buzzerLeft, 1200, DAUER);   // Ton mit 1200 Hz bei Select-Taster
  }
}
