#include <TM1637Display.h>  // Bibliothek für die 4-stellige 7-Segment-Anzeige (TM1637)
#include <Bounce2.h>        // Bibliothek zur Entprellung von Tastern

// Pins für die 7-Segment-Anzeige definieren
#define segmentanzeige_CLK 3
#define segmentanzeige_DIO 4
TM1637Display display(segmentanzeige_CLK, segmentanzeige_DIO);  // Anzeige initialisieren

// Taster-Pins definieren
#define tasterPlus 8
#define tasterMinus 6

// Entprell-Objekte für beide Taster
Bounce bceTasterPlus = Bounce();
Bounce bceTasterMinus = Bounce();

int counter = 0;  // Zählerwert, der auf der Anzeige dargestellt wird

void setup() {
  display.setBrightness(7);  // Helligkeit der Anzeige (0-7)

  // Taster einrichten (mit internem Pullup) und Entprellzeit setzen
  bceTasterPlus.attach(tasterPlus, INPUT_PULLUP);
  bceTasterPlus.interval(5);

  bceTasterMinus.attach(tasterMinus, INPUT_PULLUP);
  bceTasterMinus.interval(5);

  // Startwert auf der Anzeige darstellen
  display.showNumberDecEx(counter, 4, 4);
}

void loop() {
  // Tasterstatus aktualisieren
  bceTasterPlus.update();
  bceTasterMinus.update();

  bool pressKey = false;  // Merker, ob ein Taster gedrückt wurde

  // Wenn der Plus-Taster gedrückt wurde: Zähler erhöhen
  if (bceTasterPlus.fell()) {
    pressKey = true;
    counter++;
  } 
  // Wenn der Minus-Taster gedrückt wurde: Zähler verringern
  else if (bceTasterMinus.fell()) {
    pressKey = true;
    counter--;
  }

  // Wenn ein Taster gedrückt wurde, aktualisiere die Anzeige
  if (pressKey) {
    display.showNumberDecEx(counter, 4, 4);  // Zahl mit aktivem Doppelpunkt anzeigen
  }
}
